from .download import download_zip
from pathlib import Path
down_path = Path(__file__).parent
xz_url = "addons_file"+"/"+down_path.name+"/"
download_zip(xz_url + "assets.zip",down_path)

bl_info = {
    "name" : "Easy Wake",
    "author" : "Blender Procedural", 
    "description" : "More free stuff for Blender: https://t.me/BlenderUniverse",
    "blender" : (3, 0, 0),
    "version" : (1, 0, 0),
    "location" : "",
    "warning" : "",
    "doc_url": "", 
    "tracker_url": "", 
    "category" : "3D View" 
}


import bpy
import bpy.utils.previews
import os


addon_keymaps = {}
_icons = None
ocean = {'sna_ship': None, 'sna_curve': None, }


def sna_update_sna_ship_7906E(self, context):
    sna_updated_prop = self.sna_ship
    bpy.data.objects['ocean'].modifiers['GeometryNodes']['Socket_2'] = sna_updated_prop
    if bpy.context and bpy.context.screen:
        for a in bpy.context.screen.areas:
            a.tag_redraw()


def sna_update_sna_ship_B8A3E(self, context):
    sna_updated_prop = self.sna_ship
    print(str(property_exists("bpy.context.scene.sna_ship", globals(), locals())), str(bpy.context.scene.sna_ship))


def load_preview_icon(path):
    global _icons
    if not path in _icons:
        if os.path.exists(path):
            _icons.load(path, path, "IMAGE")
        else:
            return 0
    return _icons[path].icon_id


def property_exists(prop_path, glob, loc):
    try:
        eval(prop_path, glob, loc)
        return True
    except:
        return False


_56680_running = False
class SNA_OT_Modal_Operator_56680(bpy.types.Operator):
    bl_idname = "sna.modal_operator_56680"
    bl_label = "Modal Operator"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}
    cursor = "CROSSHAIR"
    _handle = None
    _event = {}

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        if not False or context.area.spaces[0].bl_rna.identifier == 'SpaceNodeEditor':
            return not False
        return False

    def save_event(self, event):
        event_options = ["type", "value", "alt", "shift", "ctrl", "oskey", "mouse_region_x", "mouse_region_y", "mouse_x", "mouse_y", "pressure", "tilt"]
        if bpy.app.version >= (3, 2, 1):
            event_options += ["type_prev", "value_prev"]
        for option in event_options: self._event[option] = getattr(event, option)

    def draw_callback_px(self, context):
        event = self._event
        if event.keys():
            event = dotdict(event)
            try:
                pass
            except Exception as error:
                print(error)

    def execute(self, context):
        global _56680_running
        _56680_running = False
        context.window.cursor_set("DEFAULT")
        for area in context.screen.areas:
            area.tag_redraw()
        return {"FINISHED"}

    def modal(self, context, event):
        global _56680_running
        if not context.area or not _56680_running:
            self.execute(context)
            return {'CANCELLED'}
        self.save_event(event)
        context.window.cursor_set('CROSSHAIR')
        try:
            pass
        except Exception as error:
            print(error)
        if event.type in ['RIGHTMOUSE', 'ESC']:
            self.execute(context)
            return {'CANCELLED'}
        return {'PASS_THROUGH'}

    def invoke(self, context, event):
        global _56680_running
        if _56680_running:
            _56680_running = False
            return {'FINISHED'}
        else:
            self.save_event(event)
            self.start_pos = (event.mouse_x, event.mouse_y)
            context.window_manager.modal_handler_add(self)
            _56680_running = True
            return {'RUNNING_MODAL'}


class SNA_OT_Draw_Curve_Fa5F7(bpy.types.Operator):
    bl_idname = "sna.draw_curve_fa5f7"
    bl_label = "draw curve"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


_9311C_running = False
class SNA_OT_Drowmod_9311C(bpy.types.Operator):
    bl_idname = "sna.drowmod_9311c"
    bl_label = "drowmod"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}
    cursor = "CROSSHAIR"
    _handle = None
    _event = {}

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        if not False or context.area.spaces[0].bl_rna.identifier == 'SpaceView3D':
            return not False
        return False

    def save_event(self, event):
        event_options = ["type", "value", "alt", "shift", "ctrl", "oskey", "mouse_region_x", "mouse_region_y", "mouse_x", "mouse_y", "pressure", "tilt"]
        if bpy.app.version >= (3, 2, 1):
            event_options += ["type_prev", "value_prev"]
        for option in event_options: self._event[option] = getattr(event, option)

    def draw_callback_px(self, context):
        event = self._event
        if event.keys():
            event = dotdict(event)
            try:
                pass
            except Exception as error:
                print(error)

    def execute(self, context):
        global _9311C_running
        _9311C_running = False
        context.window.cursor_set("DEFAULT")
        bpy.ops.object.mode_set('INVOKE_DEFAULT', mode='OBJECT')
        ocean['sna_ship'].constraints['Follow Path'].target = ocean['sna_curve']
        bpy.context.view_layer.objects.active = ocean['sna_ship']
        bpy.ops.constraint.followpath_path_animate('INVOKE_DEFAULT', constraint='Follow Path', owner='OBJECT')
        ocean['sna_ship'].constraints['Follow Path'].use_curve_follow = True
        bpy.data.objects['ocean'].modifiers['GeometryNodes']['Socket_2'] = ocean['sna_ship']
        print(str(ocean['sna_ship']))
        bpy.ops.screen.frame_jump('INVOKE_DEFAULT', )
        bpy.data.objects['ocean'].modifiers['GeometryNodes']['Socket_4'] = 250.0
        bpy.data.objects['ocean'].use_simulation_cache = (not bpy.data.objects['ocean'].use_simulation_cache)
        bpy.data.objects['ocean'].use_simulation_cache = (not bpy.data.objects['ocean'].use_simulation_cache)
        for area in context.screen.areas:
            area.tag_redraw()
        return {"FINISHED"}

    def modal(self, context, event):
        global _9311C_running
        if not context.area or not _9311C_running:
            self.execute(context)
            return {'CANCELLED'}
        self.save_event(event)
        context.window.cursor_set('CROSSHAIR')
        try:
            bpy.ops.wm.tool_set_by_index('INVOKE_DEFAULT', index=15, space_type='VIEW_3D')
            length_08883 = bpy.context.view_layer.objects.active.data.splines.active.calc_length()
            if bpy.context.view_layer.objects.active.type == 'CURVE':
                ocean['sna_curve'] = bpy.context.view_layer.objects.active
            bpy.data.curves[bpy.context.object.data.name].dimensions = '2D'
            print(str((event.value == 'NOTHING')))
            if event.type in ['RIGHTMOUSE', 'ESC']:
                self.execute(context)
                return {'CANCELLED'}
            self.execute(context)
            return {"FINISHED"}
        except Exception as error:
            print(error)
        if event.type in ['RIGHTMOUSE', 'ESC']:
            self.execute(context)
            return {'CANCELLED'}
        return {'PASS_THROUGH'}

    def invoke(self, context, event):
        global _9311C_running
        if _9311C_running:
            _9311C_running = False
            return {'FINISHED'}
        else:
            self.save_event(event)
            self.start_pos = (event.mouse_x, event.mouse_y)
            ocean['sna_ship'] = bpy.data.objects['ocean'].modifiers['GeometryNodes']['Socket_2']
            print(str(ocean['sna_ship']))
            if property_exists("bpy.data.objects['ocean'].modifiers['GeometryNodes']['Socket_2'].constraints['Follow Path'].offset", globals(), locals()):
                pass
            else:
                bpy.ops.object.constraint_add('INVOKE_DEFAULT', type='FOLLOW_PATH')
            bpy.ops.curve.primitive_nurbs_curve_add('INVOKE_DEFAULT', )
            bpy.ops.object.mode_set('INVOKE_DEFAULT', mode='EDIT')
            bpy.ops.curve.delete('INVOKE_DEFAULT', type='VERT')
            ocean['sna_curve'] = bpy.context.view_layer.objects.active
            if bpy.context and bpy.context.screen:
                for a in bpy.context.screen.areas:
                    a.tag_redraw()
            context.window_manager.modal_handler_add(self)
            _9311C_running = True
            return {'RUNNING_MODAL'}


class SNA_OT_Select_As_Ship_2E5Ca(bpy.types.Operator):
    bl_idname = "sna.select_as_ship_2e5ca"
    bl_label = "Select As Ship"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        bpy.data.objects['ocean'].modifiers['GeometryNodes']['Socket_2'] = bpy.context.view_layer.objects.active
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_PT_EASY_WAKE_D32FA(bpy.types.Panel):
    bl_label = 'Easy Wake'
    bl_idname = 'SNA_PT_EASY_WAKE_D32FA'
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_context = ''
    bl_category = 'Easy Wake'
    bl_order = 0
    bl_ui_units_x=0

    @classmethod
    def poll(cls, context):
        return not (False)

    def draw_header(self, context):
        layout = self.layout
        layout.template_icon(icon_value=load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'blender_community_badge_white.png')), scale=1.3299999237060547)

    def draw(self, context):
        layout = self.layout
        layout.template_icon(icon_value=load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'LOGO.png')), scale=6.519999980926514)
        box_7ADDA = layout.box()
        box_7ADDA.alert = False
        box_7ADDA.enabled = True
        box_7ADDA.active = True
        box_7ADDA.use_property_split = False
        box_7ADDA.use_property_decorate = False
        box_7ADDA.alignment = 'Expand'.upper()
        box_7ADDA.scale_x = 2.5
        box_7ADDA.scale_y = 2.5
        if not True: box_7ADDA.operator_context = "EXEC_DEFAULT"
        op = box_7ADDA.operator('sna.add_ocean_17f7a', text='Add Dynamic Ocean', icon_value=478, emboss=True, depress=False)
        if property_exists("bpy.data.objects['ocean']", globals(), locals()):
            box_7ADDA.prop(bpy.context.scene, 'sna_ship', text='Ship', icon_value=0, emboss=True)
        if (None != bpy.context.scene.sna_ship):
            box_46F59 = layout.box()
            box_46F59.alert = False
            box_46F59.enabled = True
            box_46F59.active = True
            box_46F59.use_property_split = False
            box_46F59.use_property_decorate = False
            box_46F59.alignment = 'Expand'.upper()
            box_46F59.scale_x = 1.0
            box_46F59.scale_y = 1.0
            if not True: box_46F59.operator_context = "EXEC_DEFAULT"
            if (None != bpy.context.scene.sna_ship):
                box_91B68 = box_46F59.box()
                box_91B68.alert = False
                box_91B68.enabled = (None != bpy.context.scene.sna_ship)
                box_91B68.active = (None != bpy.context.scene.sna_ship)
                box_91B68.use_property_split = False
                box_91B68.use_property_decorate = False
                box_91B68.alignment = 'Expand'.upper()
                box_91B68.scale_x = 2.3499999046325684
                box_91B68.scale_y = 2.3499999046325684
                if not True: box_91B68.operator_context = "EXEC_DEFAULT"
                op = box_91B68.operator('sna.drowmod_9311c', text='Draw Ship Path', icon_value=457, emboss=True, depress=False)
            split_E088F = box_46F59.split(factor=0.550000011920929, align=False)
            split_E088F.alert = False
            split_E088F.enabled = True
            split_E088F.active = True
            split_E088F.use_property_split = False
            split_E088F.use_property_decorate = False
            split_E088F.scale_x = 1.0
            split_E088F.scale_y = 1.0
            split_E088F.alignment = 'Expand'.upper()
            if not True: split_E088F.operator_context = "EXEC_DEFAULT"
            split_E088F.label(text='Path Settings:', icon_value=0)
            split_E088F.label(text='Animate', icon_value=841)
            try:
                box_46F59.prop(bpy.data.curves[ocean['sna_curve'].data.name], 'path_duration', text='Path Duration', icon_value=0, emboss=True)
                box_46F59.prop(ocean['sna_ship'].constraints['Follow Path'], 'forward_axis', text='Axis', icon_value=0, emboss=True)
            except:
                pass


class SNA_OT_Add_Ocean_17F7A(bpy.types.Operator):
    bl_idname = "sna.add_ocean_17f7a"
    bl_label = "add ocean"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        if property_exists("bpy.data.objects['ocean']", globals(), locals()):
            pass
        else:
            before_data = list(bpy.data.objects)
            bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'RND.blend') + r'\Object', filename='OceanGround', link=False)
            new_data = list(filter(lambda d: not d in before_data, list(bpy.data.objects)))
            appended_D904B = None if not new_data else new_data[0]
            if property_exists("bpy.data.objects['ship']", globals(), locals()):
                bpy.data.objects.remove(object=bpy.data.objects['ship'], do_ui_user=False, )
                bpy.data.objects.remove(object=bpy.data.objects['NurbsCurve'], )
                bpy.data.scenes['Scene'].render.engine = 'CYCLES'
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_PT_PROPERTIES_8D19D(bpy.types.Panel):
    bl_label = 'Properties'
    bl_idname = 'SNA_PT_PROPERTIES_8D19D'
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_context = ''
    bl_order = 1
    bl_parent_id = 'SNA_PT_EASY_WAKE_D32FA'
    bl_ui_units_x=0

    @classmethod
    def poll(cls, context):
        return not ((not property_exists("bpy.data.objects['ocean']", globals(), locals())))

    def draw_header(self, context):
        layout = self.layout

    def draw(self, context):
        layout = self.layout
        layout.label(text='Ocean Settings', icon_value=478)
        box_7B7A6 = layout.box()
        box_7B7A6.alert = False
        box_7B7A6.enabled = True
        box_7B7A6.active = True
        box_7B7A6.use_property_split = False
        box_7B7A6.use_property_decorate = False
        box_7B7A6.alignment = 'Expand'.upper()
        box_7B7A6.scale_x = 1.0
        box_7B7A6.scale_y = 1.0
        if not True: box_7B7A6.operator_context = "EXEC_DEFAULT"
        col_5708B = box_7B7A6.column(heading='', align=False)
        col_5708B.alert = False
        col_5708B.enabled = True
        col_5708B.active = True
        col_5708B.use_property_split = False
        col_5708B.use_property_decorate = False
        col_5708B.scale_x = 1.0
        col_5708B.scale_y = 1.0
        col_5708B.alignment = 'Expand'.upper()
        col_5708B.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        col_5708B.prop(bpy.data.objects['ocean'].modifiers['Ocean'], 'viewport_resolution', text='Viewport Resolution', icon_value=0, emboss=True)
        col_5708B.prop(bpy.data.objects['ocean'].modifiers['Ocean'], 'resolution', text='Render Resolution', icon_value=0, emboss=True)
        col_5708B.prop(bpy.data.objects['ocean'].modifiers['Ocean'], 'time', text='Time', icon_value=0, emboss=True)
        col_5708B.prop(bpy.data.objects['ocean'].modifiers['Ocean'], 'depth', text='Depth', icon_value=0, emboss=True)
        col_5708B.prop(bpy.data.objects['ocean'].modifiers['Ocean'], 'size', text='Size', icon_value=0, emboss=True)
        col_5708B.prop(bpy.data.objects['ocean'].modifiers['Ocean'], 'spatial_size', text='Spatial Size', icon_value=0, emboss=True)
        col_5708B.prop(bpy.data.objects['ocean'].modifiers['Ocean'], 'random_seed', text='Random Seed', icon_value=0, emboss=True)
        col_0940C = box_7B7A6.column(heading='Wave Settings:', align=False)
        col_0940C.alert = False
        col_0940C.enabled = True
        col_0940C.active = True
        col_0940C.use_property_split = False
        col_0940C.use_property_decorate = False
        col_0940C.scale_x = 1.0
        col_0940C.scale_y = 1.0
        col_0940C.alignment = 'Expand'.upper()
        col_0940C.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
        col_0940C.prop(bpy.data.objects['ocean'].modifiers['Ocean'], 'wave_scale', text='Scale', icon_value=0, emboss=True)
        col_0940C.prop(bpy.data.objects['ocean'].modifiers['Ocean'], 'wave_scale_min', text='Smallest Wave', icon_value=0, emboss=True)
        col_0940C.prop(bpy.data.objects['ocean'].modifiers['Ocean'], 'choppiness', text='Choppiness', icon_value=0, emboss=True)
        col_0940C.prop(bpy.data.objects['ocean'].modifiers['Ocean'], 'wind_velocity', text='Wind Velocity', icon_value=0, emboss=True)
        col_0940C.label(text='Spectrum:', icon_value=0)
        col_0940C.prop(bpy.data.objects['ocean'].modifiers['Ocean'], 'spectrum', text='', icon_value=0, emboss=True)
        layout.label(text='Simulation Settings', icon_value=470)
        box_1D9F7 = layout.box()
        box_1D9F7.alert = False
        box_1D9F7.enabled = True
        box_1D9F7.active = True
        box_1D9F7.use_property_split = False
        box_1D9F7.use_property_decorate = False
        box_1D9F7.alignment = 'Expand'.upper()
        box_1D9F7.scale_x = 1.0
        box_1D9F7.scale_y = 1.0
        if not True: box_1D9F7.operator_context = "EXEC_DEFAULT"
        attr_DC2A3 = '["' + str('Socket_2' + '"]') 
        box_1D9F7.prop(bpy.data.objects['ocean'].modifiers['GeometryNodes'], attr_DC2A3, text='Ship', icon_value=0, emboss=True)
        op = box_1D9F7.operator('sna.select_as_ship_2e5ca', text='Select Ship', icon_value=0, emboss=True, depress=False)
        attr_92500 = '["' + str('Socket_3' + '"]') 
        box_1D9F7.prop(bpy.data.objects['ocean'].modifiers['GeometryNodes'], attr_92500, text='Velocity', icon_value=0, emboss=True)
        attr_1B743 = '["' + str('Socket_4' + '"]') 
        box_1D9F7.prop(bpy.data.objects['ocean'].modifiers['GeometryNodes'], attr_1B743, text='Particle Density', icon_value=0, emboss=True)
        attr_B7E36 = '["' + str('Socket_5' + '"]') 
        box_1D9F7.prop(bpy.data.objects['ocean'].modifiers['GeometryNodes'], attr_B7E36, text='Age', icon_value=0, emboss=True)
        attr_4A28E = '["' + str('Socket_6' + '"]') 
        box_1D9F7.prop(bpy.data.objects['ocean'].modifiers['GeometryNodes'], attr_4A28E, text='Particle Radius', icon_value=0, emboss=True)
        attr_DE38A = '["' + str('Socket_7' + '"]') 
        box_1D9F7.prop(bpy.data.objects['ocean'].modifiers['GeometryNodes'], attr_DE38A, text='Ocean Velocity', icon_value=0, emboss=True)
        attr_3CD7D = '["' + str('Socket_8' + '"]') 
        box_1D9F7.prop(bpy.data.objects['ocean'].modifiers['GeometryNodes'], attr_3CD7D, text='Noise Amount', icon_value=0, emboss=True)
        attr_16F5A = '["' + str('Socket_9' + '"]') 
        box_1D9F7.prop(bpy.data.objects['ocean'].modifiers['GeometryNodes'], attr_16F5A, text='Secondary Noise', icon_value=0, emboss=True)
        layout.label(text='Baking', icon_value=192)
        box_ED3BE = layout.box()
        box_ED3BE.alert = False
        box_ED3BE.enabled = True
        box_ED3BE.active = True
        box_ED3BE.use_property_split = False
        box_ED3BE.use_property_decorate = False
        box_ED3BE.alignment = 'Expand'.upper()
        box_ED3BE.scale_x = 1.0
        box_ED3BE.scale_y = 1.0
        if not True: box_ED3BE.operator_context = "EXEC_DEFAULT"
        split_B2016 = box_ED3BE.split(factor=0.6277777552604675, align=False)
        split_B2016.alert = False
        split_B2016.enabled = True
        split_B2016.active = True
        split_B2016.use_property_split = False
        split_B2016.use_property_decorate = False
        split_B2016.scale_x = 1.0
        split_B2016.scale_y = 1.0
        split_B2016.alignment = 'Expand'.upper()
        if not True: split_B2016.operator_context = "EXEC_DEFAULT"
        split_B2016.label(text='Cache Settings', icon_value=0)
        split_B2016.prop(bpy.data.objects['ocean'], 'use_simulation_cache', text='Cache', icon_value=0, emboss=True)
        box_0CD6E = box_ED3BE.box()
        box_0CD6E.alert = False
        box_0CD6E.enabled = True
        box_0CD6E.active = True
        box_0CD6E.use_property_split = False
        box_0CD6E.use_property_decorate = False
        box_0CD6E.alignment = 'Expand'.upper()
        box_0CD6E.scale_x = 1.0
        box_0CD6E.scale_y = 1.0
        if not True: box_0CD6E.operator_context = "EXEC_DEFAULT"
        split_A6D57 = box_0CD6E.split(factor=1.0, align=False)
        split_A6D57.alert = False
        split_A6D57.enabled = True
        split_A6D57.active = True
        split_A6D57.use_property_split = False
        split_A6D57.use_property_decorate = False
        split_A6D57.scale_x = 1.0
        split_A6D57.scale_y = 1.0
        split_A6D57.alignment = 'Expand'.upper()
        if not True: split_A6D57.operator_context = "EXEC_DEFAULT"
        op = split_A6D57.operator('object.simulation_nodes_cache_calculate_to_frame', text='Calculate To Frame', icon_value=0, emboss=True, depress=False)
        split_BECD2 = box_0CD6E.split(factor=0.44999998807907104, align=False)
        split_BECD2.alert = False
        split_BECD2.enabled = True
        split_BECD2.active = True
        split_BECD2.use_property_split = False
        split_BECD2.use_property_decorate = False
        split_BECD2.scale_x = 1.0
        split_BECD2.scale_y = 1.0
        split_BECD2.alignment = 'Expand'.upper()
        if not True: split_BECD2.operator_context = "EXEC_DEFAULT"
        op = split_BECD2.operator('object.simulation_nodes_cache_bake', text='Bake Simulation', icon_value=0, emboss=True, depress=False)
        op = split_BECD2.operator('object.simulation_nodes_cache_delete', text='Delete Cache', icon_value=0, emboss=True, depress=False)


def sna_update_sna_ship(self, context):
    sna_update_sna_ship_7906E(self, context)
    sna_update_sna_ship_B8A3E(self, context)


def register():
    global _icons
    _icons = bpy.utils.previews.new()
    bpy.types.Scene.sna_ship = bpy.props.PointerProperty(name='Ship', description='', type=bpy.types.Object, update=sna_update_sna_ship)
    bpy.utils.register_class(SNA_OT_Modal_Operator_56680)
    bpy.utils.register_class(SNA_OT_Draw_Curve_Fa5F7)
    bpy.utils.register_class(SNA_OT_Drowmod_9311C)
    bpy.utils.register_class(SNA_OT_Select_As_Ship_2E5Ca)
    bpy.utils.register_class(SNA_PT_EASY_WAKE_D32FA)
    bpy.utils.register_class(SNA_OT_Add_Ocean_17F7A)
    bpy.utils.register_class(SNA_PT_PROPERTIES_8D19D)


def unregister():
    global _icons
    bpy.utils.previews.remove(_icons)
    wm = bpy.context.window_manager
    kc = wm.keyconfigs.addon
    for km, kmi in addon_keymaps.values():
        km.keymap_items.remove(kmi)
    addon_keymaps.clear()
    del bpy.types.Scene.sna_ship
    bpy.utils.unregister_class(SNA_OT_Modal_Operator_56680)
    bpy.utils.unregister_class(SNA_OT_Draw_Curve_Fa5F7)
    bpy.utils.unregister_class(SNA_OT_Drowmod_9311C)
    bpy.utils.unregister_class(SNA_OT_Select_As_Ship_2E5Ca)
    bpy.utils.unregister_class(SNA_PT_EASY_WAKE_D32FA)
    bpy.utils.unregister_class(SNA_OT_Add_Ocean_17F7A)
    bpy.utils.unregister_class(SNA_PT_PROPERTIES_8D19D)
